#ifndef __SELECTFOLDER_H__
#define __SELECTFOLDER_H__

#include <stdio.h>
#include <shlobj.h>

char	g_path[MAX_PATH] = "";

int 	CALLBACK ProcBrowse(HWND hWnd, UINT uMsg, LPARAM lp, LPARAM pData);
bool	Set_Dir(HWND hWnd);
void	_SHFree(void *p);

// tH_[I_CAO vV[W
int CALLBACK ProcBrowse(HWND hWnd, UINT uMsg, LPARAM lp, LPARAM pData)
{
	TCHAR szDir[MAX_PATH];

	switch(uMsg) {
		case BFFM_INITIALIZED:
			{
				if (strcmp(g_path,"")) {
					// WParam is TRUE since you are passing a path.
					// It would be FALSE if you were passing a pidl.
					SendMessage(hWnd,BFFM_SETSELECTION,TRUE,(LPARAM)g_path);
				}
				break;
			}
		case BFFM_SELCHANGED:
			{
				// Set the status window to the currently selected path.
				if (SHGetPathFromIDList((LPITEMIDLIST) lp ,szDir)) {
					SendMessage(hWnd,BFFM_SETSTATUSTEXT,0,(LPARAM)szDir);
				}
				break;
			}
		default:
			break;
	}
	return 0;
}// ProcBrowse

bool Set_Dir(HWND hWnd)
{
	BROWSEINFO bi;
	LPITEMIDLIST pidl;
	char ach[MAX_PATH];
	
	bi.hwndOwner	  = hWnd;
	bi.pidlRoot 	  = NULL;
	bi.pszDisplayName = ach;
	bi.lpszTitle	  = "|C^̕ۑtH_[w肵Ă";
	bi.ulFlags		  = BIF_RETURNONLYFSDIRS | BIF_STATUSTEXT;
	bi.lpfn 		  = ProcBrowse;
	bi.lParam		  = 0;
	bi.iImage		  = 0;
	pidl = SHBrowseForFolder(&bi);
	if (pidl)
	{
		SHGetPathFromIDList(pidl, ach);
		strcpy(g_path, ach);
		_SHFree(pidl);
		return true;
	}
	return false;
}// Set_Dir

void _SHFree(void *p)
{
	IMalloc *pm;
	SHGetMalloc(&pm);
	if (pm)
	{
		pm->Free(p);
		pm->Release();
	}
}// _SHFree

#endif // __SELECTFOLDER_H__
